#ifndef minimisation_h
#define minimisation_h 1

#include<iostream>


// Classe minimisation qui définit plusieurs sous-classes contenant des fonctions d'optimisation

using namespace std;

class minimisation
{
 public:
  minimisation();
  ~minimisation();

  virtual void initialise(string empl);  // Declaration du fichier de données à utiliser
  string read(); 

 private:
  string fich;

};

class mcarres: public minimisation
{
 public:
  mcarres(double* ath, double* bth); 
  ~mcarres();

  void initialise();  // Calcul du khi2 avec les données fich et en fonction de a et b définis grâce au constructeur
  double read();
  
 private:
  double* a;
  double* b;
  double khi2;
};


class fonction: public minimisation
{
 public:
  fonction();
  fonction(double* x1);
  ~fonction();

  double fct();   // Fonction dépendante de x
 private:
  double* x;


};

class dist: public minimisation
{
 public:
  dist(int n1, int*li);
  ~dist();

  void set();   // Stockage d'une matrice contenant les éléments de fich dans mat
  void initialise();   // Calcul de la distance avec liste et mat
  double read(); 

 private:
  int n;
  double distance;
  double** mat;
  int*liste;
};
  


#endif
