void PISTAvsTime(int runStart, int runStop)
{
  TChain *ch=new TChain("PhysicsTree");
  for(int run=runStart;run<=runStop;run++)
    ch->Add(Form("../root/analysis/run_%d.root",run));

  TH2F* hDEvsTime[8] ;  
  TH2F* hEresvsTime[8]; 
  for (int i=0;i<8;i++){  
    hDEvsTime[i] = new TH2F(Form("hDEvsTimeTeles%d",i+1) , Form("hDEvsTimeTeles%d",i+1) ,1750,25,150,1000,0,60);
    hEresvsTime[i] = new TH2F(Form("hEresvsTimeTeles%d",i+1),Form("hEresvsTimeTeles%d",i+1),1750,25,150,1000,0,200);
  }
  double DeltaE;
  double Eres;
  double ThetaLab,PhiLab;
  int Telescope , strip_E,strip_DE;
  long int fVAMOS_TS_sec;
  
  ch->SetBranchStatus("DeltaE",true);
  ch->SetBranchAddress("DeltaE",&DeltaE);
  ch->SetBranchStatus("Eres",true);
  ch->SetBranchAddress("Eres",&Eres);
  ch->SetBranchStatus("Telescope",true);
  ch->SetBranchAddress("Telescope",&Telescope);
  ch->SetBranchStatus("ThetaLab",true);
  ch->SetBranchAddress("ThetaLab",&ThetaLab);
  ch->SetBranchStatus("fVAMOS_TS_sec",true);
  ch->SetBranchAddress("fVAMOS_TS_sec",&fVAMOS_TS_sec);
  ch->SetBranchStatus("PhiLab",true);
  ch->SetBranchAddress("PhiLab",&PhiLab);
  ch->SetBranchStatus("strip_E",true);
  ch->SetBranchAddress("strip_E",&strip_E);
  ch->SetBranchStatus("strip_DE",true);
  ch->SetBranchAddress("strip_DE",&strip_DE);
  
  int Nentries=ch->GetEntries();
  
  for(int e=0;e<Nentries;e++)
    {
      if(e%1000000==0) cout << e*100./Nentries << "% \r" << flush;

      ch->GetEntry(e);
      double PhiTel[8]={90,135,175,-135,-90,-45,0,45};
      if (/*abs(ThetaLab-40)<2*/ strip_DE == 1 ){hDEvsTime[Telescope-1]->Fill(fVAMOS_TS_sec/3600.,DeltaE);}
      if (/*abs(PhiLab*180/3.1415-PhiTel[Telescope-1]) < 2*/ strip_E == 1 ){hEresvsTime[Telescope-1]->Fill(fVAMOS_TS_sec/3600.,Eres);}

    }  

  /*TCanvas *c1=new TCanvas("c1","c1",1500,1000);
  c1->Divide(1,2);
  c1->cd(1);
  hDEvsTime->Draw("colz");
  c1->cd(2);
  hEresvsTime->Draw("colz");
  */
  TFile *ofile = new TFile(Form("hist/histo_de_eres_time%d_%d.root",runStart,runStop),"recreate");
  
  for (int i=0 ;i<8;i++){
    hDEvsTime[i]->Write();
    hEresvsTime[i]->Write();
  }
  ofile->Close();
}

