const int Ncuts=39;
TCutG *cut[Ncuts];

int IdentifyZ(double,double);

void QvsTime(int runStart, int runStop)
{
  TChain *ch=new TChain("PhysicsTree");
  for(int run=runStart;run<=runStop;run++)
    ch->Add(Form("../root/analysis/run_%d.root",run));

  TH2F* hQvsTime=new TH2F("hQvsTime","hQvsTime",5000,0,200,1000,25,55);
  TH2F* hChio_DEvsTime=new TH2F("hChio_DEvsTime","hChio_DEvsTime",5000,0,200,1000,-10e3,10e3);
  TH2F* hAoQvsTime=new TH2F("hAoQvsTime","hAoQvsTime",5000,0,200,1000,2.5,5.5);

  TFile* fcutEvamos=new TFile("cutEvamos.root");
  TCutG* cutEvamos=(TCutG*)fcutEvamos->Get("cutEvamos");

  TFile *fcutChio=new TFile("Chio_Cuts_Lucas.root");
  for(int i=0;i<39;i++) cut[i]=(TCutG*)fcutChio->Get(Form("ZGates%d",i+29));



  double Q, Chio_E, Chio_DE, Evamos,AoQ;
  long int fVAMOS_TS_sec;
  
  ch->SetBranchStatus("Q",true);
  ch->SetBranchAddress("Q",&Q);
  ch->SetBranchStatus("fVAMOS_TS_sec",true);
  ch->SetBranchAddress("fVAMOS_TS_sec",&fVAMOS_TS_sec);
  ch->SetBranchStatus("Chio_Ebis",true);
  ch->SetBranchAddress("Chio_Ebis",&Chio_E);
  ch->SetBranchStatus("Chio_DE",true);
  ch->SetBranchAddress("Chio_DE",&Chio_DE);
  ch->SetBranchStatus("Evamos",true);
  ch->SetBranchAddress("Evamos",&Evamos);
  ch->SetBranchStatus("AoQ",true);
  ch->SetBranchAddress("AoQ",&AoQ);

  int Nentries=ch->GetEntries();
  
  for(int e=0;e<Nentries;e++)
    {
      if(e%1000000==0) cout << e*100./Nentries << "% \r" << flush;

      ch->GetEntry(e);
      hQvsTime->Fill(fVAMOS_TS_sec/3600.,Q);

    
      double Chio_DEcorr=Chio_DE+5.99061*Evamos-18168.7;
      if(cutEvamos->IsInside(Evamos,Chio_DEcorr))
	hChio_DEvsTime->Fill(fVAMOS_TS_sec/3600.,Chio_DEcorr);

      //if(cut[20]->IsInside(Chio_E,Chio_DE))
      hAoQvsTime->Fill(fVAMOS_TS_sec/3600.,AoQ);
	

    }  

  TCanvas *c1=new TCanvas("c1","c1",1500,500);
  c1->Divide(3,1);
  c1->cd(1);
  hQvsTime->GetXaxis()->SetTitle("Time (h)");
  hQvsTime->GetYaxis()->SetTitle("Q");
  hQvsTime->Draw("colz");
  c1->cd(2);
  hChio_DEvsTime->Draw("colz");
  c1->cd(3);
  hAoQvsTime->Draw("colz");

  hQvsTime->SaveAs(Form("hist/QvsTime/fQvsTime_run%d-%d.png",runStart,runStop));

  TFile *outfile=new TFile(Form("hist/QvsTime/fQvsTime_run%d-%d.root",runStart,runStop),"recreate");
  hQvsTime->Write();
  hChio_DEvsTime->Write();
  hAoQvsTime->Write();

  c1->Write();
  outfile->Close();
  //  c1->SaveAs(Form("hist/QvsTime/fQvsTime_run%d-%d.root",runStart,runStop));
  

}

int IdentifyZ(double Chio_E, double Chio_DE)
{

  if(cut[0]->IsInside(Chio_E,Chio_DE)) return 0;
  else if(cut[1]->IsInside(Chio_E,Chio_DE)) return 1;
  else if(cut[2]->IsInside(Chio_E,Chio_DE)) return 2;
  else if(cut[3]->IsInside(Chio_E,Chio_DE)) return 3;
  else if(cut[4]->IsInside(Chio_E,Chio_DE)) return 4;
  else if(cut[5]->IsInside(Chio_E,Chio_DE)) return 5;
  else if(cut[6]->IsInside(Chio_E,Chio_DE)) return 6;
  else if(cut[7]->IsInside(Chio_E,Chio_DE)) return 7;
  else if(cut[8]->IsInside(Chio_E,Chio_DE)) return 8;
  else if(cut[9]->IsInside(Chio_E,Chio_DE)) return 9;
  else if(cut[10]->IsInside(Chio_E,Chio_DE)) return 10;
  else if(cut[11]->IsInside(Chio_E,Chio_DE)) return 11;
  else if(cut[12]->IsInside(Chio_E,Chio_DE)) return 12;
  else if(cut[13]->IsInside(Chio_E,Chio_DE)) return 13;
  else if(cut[14]->IsInside(Chio_E,Chio_DE)) return 14;
  else if(cut[15]->IsInside(Chio_E,Chio_DE)) return 15;
  else if(cut[16]->IsInside(Chio_E,Chio_DE)) return 16;
  else if(cut[17]->IsInside(Chio_E,Chio_DE)) return 17;
  else if(cut[18]->IsInside(Chio_E,Chio_DE)) return 18;
  else if(cut[19]->IsInside(Chio_E,Chio_DE)) return 19;
  else if(cut[20]->IsInside(Chio_E,Chio_DE)) return 20;
  else if(cut[21]->IsInside(Chio_E,Chio_DE)) return 21;
  else if(cut[22]->IsInside(Chio_E,Chio_DE)) return 22;
  else if(cut[23]->IsInside(Chio_E,Chio_DE)) return 23;
  else if(cut[24]->IsInside(Chio_E,Chio_DE)) return 24;
  else if(cut[25]->IsInside(Chio_E,Chio_DE)) return 25;
  else if(cut[26]->IsInside(Chio_E,Chio_DE)) return 26;
  else if(cut[27]->IsInside(Chio_E,Chio_DE)) return 27;
  else if(cut[28]->IsInside(Chio_E,Chio_DE)) return 28;
  else if(cut[29]->IsInside(Chio_E,Chio_DE)) return 29;
  else if(cut[30]->IsInside(Chio_E,Chio_DE)) return 30;
  else if(cut[31]->IsInside(Chio_E,Chio_DE)) return 31;
  else if(cut[32]->IsInside(Chio_E,Chio_DE)) return 32;
  else if(cut[33]->IsInside(Chio_E,Chio_DE)) return 33;
  else if(cut[34]->IsInside(Chio_E,Chio_DE)) return 34;
  else if(cut[35]->IsInside(Chio_E,Chio_DE)) return 35;
  else if(cut[36]->IsInside(Chio_E,Chio_DE)) return 36;
  else if(cut[37]->IsInside(Chio_E,Chio_DE)) return 37;
  else if(cut[38]->IsInside(Chio_E,Chio_DE)) return 38;
  else return -1;
}
