#!/usr/bin/bash

# Define the paths and options
DETECTOR_CONFIG="DetectorConfiguration/EdinburghDSSD.detector"
EVENT_SOURCE="Beam/Ra224.beam"
OUTPUT_DIR="E2ADC_bigstat"
MACRO="macros/run.mac"

# Check if the npanalysis command is available
if command -v npanalysis &> /dev/null; then
  # Execute the npanalysis command
  npsimulation -D "$DETECTOR_CONFIG" -E "$EVENT_SOURCE" -O "$OUTPUT_DIR" -B "$MACRO"
else
  echo "Error: npsimulation command not found. Make sure it's installed and in your PATH."
  exit 1
fi
