void compare_theta() {

  gStyle->SetOptStat(1111111);
  gStyle->SetOptFit(1);

  TFile *file = TFile::Open("./root/analysis/c12_p2p_xz.root");
//  TTree *tree = (TTree*)file->Get("SimulatedTree");
  TTree *tree = (TTree*)file->Get("PhysicsTree");


  double VertexX;
  double VertexY;
  double VertexZ;
  double VertexX_sim;
  double VertexY_sim;
  double VertexZ_sim;
  double deltaX;
  double deltaY;
  double deltaZ;
  double SiInnerZ1_X;
  double SiInnerZ1_Y;
  double SiInnerZ1_Z;
  double SiOuterZ1_X;
  double SiOuterZ1_Y;
  double SiOuterZ1_Z;
  double SiInnerZ1_X_sim;
  double SiInnerZ1_Y_sim;
  double SiInnerZ1_Z_sim;
  double SiOuterZ1_X_sim;
  double SiOuterZ1_Y_sim;
  double SiOuterZ1_Z_sim;

  double SiInnerX1_X;
  double SiInnerX1_Y;
  double SiInnerX1_Z;
  double SiInnerX1_X_sim;
  double SiInnerX1_Y_sim;
  double SiInnerX1_Z_sim;

  double theta_vertex_1_sim;
  double theta_vertex_2_sim;

  double InnerZ1_theta_sim;
  double InnerX1_theta_sim;
  double OuterZ1_theta_sim;

  tree->SetBranchAddress("VertexX",&VertexX);
  tree->SetBranchAddress("VertexY",&VertexY);
  tree->SetBranchAddress("VertexZ",&VertexZ);
  tree->SetBranchAddress("VertexX_sim",&VertexX_sim);
  tree->SetBranchAddress("VertexY_sim",&VertexY_sim);
  tree->SetBranchAddress("VertexZ_sim",&VertexZ_sim);
  tree->SetBranchAddress("deltaX",&deltaX);
  tree->SetBranchAddress("deltaY",&deltaY);
  tree->SetBranchAddress("deltaZ",&deltaZ);

  tree->SetBranchAddress("SiInnerZ1_X",&SiInnerZ1_X);
  tree->SetBranchAddress("SiInnerZ1_Y",&SiInnerZ1_Y);
  tree->SetBranchAddress("SiInnerZ1_Z",&SiInnerZ1_Z);
  tree->SetBranchAddress("SiOuterZ1_X",&SiOuterZ1_X);
  tree->SetBranchAddress("SiOuterZ1_Y",&SiOuterZ1_Y);
  tree->SetBranchAddress("SiOuterZ1_Z",&SiOuterZ1_Z);
  tree->SetBranchAddress("SiInnerZ1_X_sim",&SiInnerZ1_X_sim);
  tree->SetBranchAddress("SiInnerZ1_Y_sim",&SiInnerZ1_Y_sim);
  tree->SetBranchAddress("SiInnerZ1_Z_sim",&SiInnerZ1_Z_sim);
  tree->SetBranchAddress("SiOuterZ1_X_sim",&SiOuterZ1_X_sim);
  tree->SetBranchAddress("SiOuterZ1_Y_sim",&SiOuterZ1_Y_sim);
  tree->SetBranchAddress("SiOuterZ1_Z_sim",&SiOuterZ1_Z_sim);


  tree->SetBranchAddress("SiInnerX1_X",&SiInnerX1_X);
  tree->SetBranchAddress("SiInnerX1_Y",&SiInnerX1_Y);
  tree->SetBranchAddress("SiInnerX1_Z",&SiInnerX1_Z);
  tree->SetBranchAddress("SiInnerX1_X_sim",&SiInnerX1_X_sim);
  tree->SetBranchAddress("SiInnerX1_Y_sim",&SiInnerX1_Y_sim);
  tree->SetBranchAddress("SiInnerX1_Z_sim",&SiInnerX1_Z_sim);

  tree->SetBranchAddress("theta_vertex_1_sim",&theta_vertex_1_sim);
  tree->SetBranchAddress("theta_vertex_2_sim",&theta_vertex_2_sim);

  tree->SetBranchAddress("InnerZ1_theta_sim",&InnerZ1_theta_sim);
  tree->SetBranchAddress("InnerX1_theta_sim",&InnerX1_theta_sim);
  tree->SetBranchAddress("OuterZ1_theta_sim",&OuterZ1_theta_sim);

  TVector3 InnerZ1;
  TVector3 OuterZ1;
  TVector3 InnerZ1_sim;
  TVector3 OuterZ1_sim;

  TVector3 InnerX1;
  TVector3 InnerX1_sim;
  TVector3 Vertex_sim;


  TVector3 VertexInnerZ;
  TVector3 InnerZInnerX;
  TVector3 InnerXOuterZ;
  TVector3 VertexInnerZ_sim;
  TVector3 InnerZInnerX_sim;
  TVector3 InnerXOuterZ_sim;

  double Theta_VertexInnerZ;
  double Theta_InnerZInnerX;
  double Theta_InnerXOuterZ;
  double Theta_VertexInnerZ_sim;
  double Theta_InnerZInnerX_sim;
  double Theta_InnerXOuterZ_sim;

  Int_t nentries = tree->GetEntries();


  TH1D *h1 = new TH1D("h1","h1",100,40,50);
  TH1D *h_targetcell = new TH1D("h_targetcell","h_targetcell",200,-0.2,0.2);
  TH1D *h_layerSi1 = new TH1D("h_layerSi1","h_layerSi1",200,-0.2,0.2);
  TH1D *h_layerSi2 = new TH1D("h_layerSi2","h_layerSi2",200,-0.2,0.2);

//  for (Int_t i = 29679; i<29680; i++) {
/*  for (Int_t i = 111663; i<111664; i++) {
    tree->GetEntry(i);
   
    Vertex_sim.SetXYZ(VertexX_sim, VertexY_sim, VertexZ_sim);

    InnerZ1.SetXYZ(SiInnerZ1_X, SiInnerZ1_Y, SiInnerZ1_Z);    
    OuterZ1.SetXYZ(SiOuterZ1_X, SiOuterZ1_Y, SiOuterZ1_Z);    
    InnerZ1_sim.SetXYZ(SiInnerZ1_X_sim, SiInnerZ1_Y_sim, SiInnerZ1_Z_sim);    
    OuterZ1_sim.SetXYZ(SiOuterZ1_X_sim, SiOuterZ1_Y_sim, SiOuterZ1_Z_sim);    
    
    InnerX1.SetXYZ(SiInnerX1_X, SiInnerX1_Y, SiInnerX1_Z); 
    InnerX1_sim.SetXYZ(SiInnerX1_X_sim, SiInnerX1_Y_sim, SiInnerX1_Z_sim); 

    VertexInnerZ = InnerZ1 - Vertex_sim;
    InnerZInnerX = InnerX1 - InnerZ1;
    InnerXOuterZ = OuterZ1 - InnerX1;
    VertexInnerZ_sim = InnerZ1_sim - Vertex_sim;
    InnerZInnerX_sim = InnerX1_sim - InnerZ1_sim;
    InnerXOuterZ_sim = OuterZ1_sim - InnerX1_sim;

    Theta_VertexInnerZ = VertexInnerZ.Theta();
    Theta_InnerZInnerX = InnerZInnerX.Theta();
    Theta_InnerXOuterZ = InnerXOuterZ.Theta();
    Theta_VertexInnerZ_sim = VertexInnerZ_sim.Theta();
    Theta_InnerZInnerX_sim = InnerZInnerX_sim.Theta();
    Theta_InnerXOuterZ_sim = InnerXOuterZ_sim.Theta();


    cout << "_____Test____" << endl;
    cout << theta_vertex_2_sim << endl;

    cout << "InnerZ theta sim: " << InnerZ1_theta_sim << endl;
    cout << "InnerX theta sim: " << InnerX1_theta_sim << endl;
    cout << "OuterZ theta sim: " << OuterZ1_theta_sim << endl;

    cout << "Vertex Sim theta: " << Vertex_sim.Theta() * 180/TMath::Pi() << endl;
    cout << "InnerZ1 theta: " << InnerZ1_sim.Theta() * 180/TMath::Pi() << endl;

    cout << VertexInnerZ_sim.Theta() * 180/TMath::Pi() << endl;
    cout << InnerZInnerX_sim.Theta() * 180/TMath::Pi() << endl;
    cout << InnerXOuterZ_sim.Theta() * 180/TMath::Pi() << endl;

    cout << "Vertex X sim: " << VertexX_sim << endl;
    cout << "Vertex Y sim: " << VertexY_sim << endl;
    cout << "Vertex Z sim: " << VertexZ_sim << endl;

    cout << "InnerZ X sim: " << SiInnerZ1_X_sim << endl;
    cout << "InnerZ Y sim: " << SiInnerZ1_Y_sim << endl;
    cout << "InnerZ Z sim: " << SiInnerZ1_Z_sim << endl;

    cout << "InnerX X sim: " << SiInnerX1_X_sim << endl;
    cout << "InnerX Y sim: " << SiInnerX1_Y_sim << endl;
    cout << "InnerX Z sim: " << SiInnerX1_Z_sim << endl;

    cout << "OuterZ X sim: " << SiOuterZ1_X_sim << endl;
    cout << "OuterZ Y sim: " << SiOuterZ1_Y_sim << endl;
    cout << "OuterZ Z sim: " << SiOuterZ1_Z_sim << endl;



    h1->Fill(SiInnerZ1_Z);
  }
*/

  for (Int_t i = 0; i<nentries; i++) {
    tree->GetEntry(i);
   
    if (theta_vertex_2_sim>44 && theta_vertex_2_sim<46) {

    Vertex_sim.SetXYZ(VertexX_sim, VertexY_sim, VertexZ_sim);

    InnerZ1.SetXYZ(SiInnerZ1_X, SiInnerZ1_Y, SiInnerZ1_Z);    
    OuterZ1.SetXYZ(SiOuterZ1_X, SiOuterZ1_Y, SiOuterZ1_Z);    
    InnerZ1_sim.SetXYZ(SiInnerZ1_X_sim, SiInnerZ1_Y_sim, SiInnerZ1_Z_sim);    
    OuterZ1_sim.SetXYZ(SiOuterZ1_X_sim, SiOuterZ1_Y_sim, SiOuterZ1_Z_sim);    
    
    InnerX1.SetXYZ(SiInnerX1_X, SiInnerX1_Y, SiInnerX1_Z); 
    InnerX1_sim.SetXYZ(SiInnerX1_X_sim, SiInnerX1_Y_sim, SiInnerX1_Z_sim); 

    VertexInnerZ = InnerZ1 - Vertex_sim;
    InnerZInnerX = InnerX1 - InnerZ1;
    InnerXOuterZ = OuterZ1 - InnerX1;
    VertexInnerZ_sim = InnerZ1_sim - Vertex_sim;
    InnerZInnerX_sim = InnerX1_sim - InnerZ1_sim;
    InnerXOuterZ_sim = OuterZ1_sim - InnerX1_sim;

    Theta_VertexInnerZ = VertexInnerZ.Theta();
    Theta_InnerZInnerX = InnerZInnerX.Theta();
    Theta_InnerXOuterZ = InnerXOuterZ.Theta();
    Theta_VertexInnerZ_sim = VertexInnerZ_sim.Theta();
    Theta_InnerZInnerX_sim = InnerZInnerX_sim.Theta();
    Theta_InnerXOuterZ_sim = InnerXOuterZ_sim.Theta();


    cout << "_____Test____" << endl;
    cout << theta_vertex_2_sim << endl;

    cout << "InnerZ theta sim: " << InnerZ1_theta_sim << endl;
    cout << "InnerX theta sim: " << InnerX1_theta_sim << endl;
    cout << "OuterZ theta sim: " << OuterZ1_theta_sim << endl;

    cout << "Vertex Sim theta: " << Vertex_sim.Theta() * 180/TMath::Pi() << endl;
    cout << "InnerZ1 theta: " << InnerZ1_sim.Theta() * 180/TMath::Pi() << endl;

    cout << VertexInnerZ_sim.Theta() * 180/TMath::Pi() << endl;
    cout << InnerZInnerX_sim.Theta() * 180/TMath::Pi() << endl;
    cout << InnerXOuterZ_sim.Theta() * 180/TMath::Pi() << endl;

    cout << "Vertex X sim: " << VertexX_sim << endl;
    cout << "Vertex Y sim: " << VertexY_sim << endl;
    cout << "Vertex Z sim: " << VertexZ_sim << endl;

    cout << "InnerZ X sim: " << SiInnerZ1_X_sim << endl;
    cout << "InnerZ Y sim: " << SiInnerZ1_Y_sim << endl;
    cout << "InnerZ Z sim: " << SiInnerZ1_Z_sim << endl;

    cout << "InnerX X sim: " << SiInnerX1_X_sim << endl;
    cout << "InnerX Y sim: " << SiInnerX1_Y_sim << endl;
    cout << "InnerX Z sim: " << SiInnerX1_Z_sim << endl;

    cout << "OuterZ X sim: " << SiOuterZ1_X_sim << endl;
    cout << "OuterZ Y sim: " << SiOuterZ1_Y_sim << endl;
    cout << "OuterZ Z sim: " << SiOuterZ1_Z_sim << endl;

    h1->Fill(theta_vertex_2_sim);
    h_targetcell->Fill(theta_vertex_2_sim * TMath::Pi()/180 - Theta_VertexInnerZ_sim); 
    h_layerSi1->Fill(theta_vertex_2_sim * TMath::Pi()/180 - Theta_InnerZInnerX_sim); 
    h_layerSi2->Fill(theta_vertex_2_sim * TMath::Pi()/180 - Theta_InnerXOuterZ_sim); 
    }
  }

  TCanvas *c1 = new TCanvas("c1","c1");
  h1->Draw();

  TCanvas *c2 = new TCanvas("c2","c2");
  c2->Divide(2,2);
  c2->cd(1);
  h_targetcell->Draw();
  h_targetcell->Fit("gaus");

  c2->cd(2);
  h_layerSi1->Draw();
  h_layerSi1->Fit("gaus");

  c2->cd(3);
  h_layerSi2->Draw();
  h_layerSi2->Fit("gaus");
}
