void plot_vertex() {
  
  gStyle->SetOptStat(1111111);
  gStyle->SetOptFit(1);

  TFile *file = TFile::Open("./root/analysis/Ca50_ppa.root");
  TTree *tree = (TTree*)file->Get("PhysicsTree");

  double VertexX;
  double VertexY;
  double VertexZ;
  double VertexX_sim;
  double VertexY_sim;
  double VertexZ_sim;
  double deltaX;
  double deltaY;
  double deltaZ;

  tree->SetBranchAddress("VertexX",&VertexX);
  tree->SetBranchAddress("VertexY",&VertexY);
  tree->SetBranchAddress("VertexZ",&VertexZ);
  tree->SetBranchAddress("VertexX_sim",&VertexX_sim);
  tree->SetBranchAddress("VertexY_sim",&VertexY_sim);
  tree->SetBranchAddress("VertexZ_sim",&VertexZ_sim);
  tree->SetBranchAddress("deltaX",&deltaX);
  tree->SetBranchAddress("deltaY",&deltaY);
  tree->SetBranchAddress("deltaZ",&deltaZ);
 
  
  TH1D* h_vertexx = new TH1D("h_vertexx","h_vertexx",200,-100,100);
  TH1D* h_vertexy = new TH1D("h_vertexy","h_vertexy",200,-100,100);
  TH1D* h_vertexz = new TH1D("h_vertexz","h_vertexz",200,-100,100);
  TH1D* h_deltax = new TH1D("h_deltax","h_deltax",200,-1,1);
  TH1D* h_deltay = new TH1D("h_deltay","h_deltay",200,-1,1);
  TH1D* h_deltaz = new TH1D("h_deltaz","h_deltaz",200,-1,1);
 
  TH1D* h_vertexx_sim = new TH1D("h_vertexx_sim","h_vertexx_sim",200,-100,100);
  TH1D* h_vertexy_sim = new TH1D("h_vertexy_sim","h_vertexy_sim",200,-100,100);
  TH1D* h_vertexz_sim = new TH1D("h_vertexz_sim","h_vertexz_sim",200,-100,100);

  Int_t nentries = tree->GetEntries();

  for (Int_t i=0; i<nentries; i++) {
    
    tree->GetEntry(i);

    h_vertexx->Fill(VertexX);
    h_vertexy->Fill(VertexY);
    h_vertexz->Fill(VertexZ);
    h_deltax->Fill(deltaX);
    h_deltay->Fill(deltaY);
    h_deltaz->Fill(deltaZ);
    h_vertexx_sim->Fill(VertexX_sim);
    h_vertexy_sim->Fill(VertexY_sim);
    h_vertexz_sim->Fill(VertexZ_sim);

  }

  TCanvas *c1 = new TCanvas("c1","c1",1200,800);
  c1->Divide(3,2);

  c1->cd(1);
  h_vertexx->Draw();
  h_vertexx->Fit("gaus");
  c1->cd(2);
  h_vertexy->Draw();
  h_vertexy->Fit("gaus");
  c1->cd(3);
  h_vertexz->Draw();
  h_vertexz->Fit("gaus");
  c1->cd(4);
  h_deltax->Draw();
  c1->cd(5);
  h_deltay->Draw();
  c1->cd(6);
  h_deltaz->Draw();


  TCanvas *c2 = new TCanvas("c2","c2",1200,800);
  c2->Divide(3,2);
  c2->cd(1);
  h_vertexx_sim->Draw();
  h_vertexx_sim->Fit("gaus");
  c2->cd(2);
  h_vertexy_sim->Draw();
  h_vertexy_sim->Fit("gaus");
  c2->cd(3);
  h_vertexz_sim->Draw();
  h_vertexz_sim->Fit("gaus");
}
