#include <ctime>
vector<TH1F*> fitEx;

  vector<int> peaksToFit{7252, 7622, 7855, 8313, 8561, 8962, 9200, 9400, 9770};
//vector<int> peaksToFit{7252, 7622, 7855,       8561, 8962, 9200, 9400, 9770};
//vector<int> peaksToFit{7622, 7855, 8313, 8554, 8962, 9200, 9400};
//vector<int> peaksToFit{7622, 7855, 8313, 8554, 8962, 9200, 9770};
//vector<int> peaksToFit{7622, 7855, 8313, 8554, 9200, 9400};
//vector<int> peaksToFit{7622, 7855, 8554, 8962, 9400};
//vector<int> peaksToFit{7622, 7855, 8554, 9200, 9400};

//string gateBase = "Mugast.TelescopeNumber<9 && ELab<(+0.05458*ThetaLab-3.651) && ELab>(-0.05458*ThetaLab+7.701) && ELab>(+0.05458*ThetaLab-5.501)"; // THIS IS NOT WORKING BECAUSE THE PHASE SPACE IS OVERSUBTRACTED!!
//string gateBase = "Mugast.TelescopeNumber<9 && ELab<(+0.05458*ThetaLab-4.301) && ELab>(-0.05458*ThetaLab+7.051) && ELab>(+0.05458*ThetaLab-4.851)"; // Ex limit = 10 MeV
string basePath = "~/Programs/nptoolv3/Outputs/Analysis/Sim_19Odp_";
string gateBase = "Mugast.TelescopeNumber<9";
string gateG    = gateBase + " && abs(T_FPMW_HF-13300)<1500";
string gateB    = gateBase + " && abs(T_FPMW_HF-10500)<1500";

  int angleMin = 104; int angleMax = 134; double angleBinWidth =  5; double exMin = 6; double exMax = 11; double exBinWidth = 0.05;
//int angleMin = 104; int angleMax = 134; double angleBinWidth = 30; double exMin = 6; double exMax = 11; double exBinWidth = 0.05;
//int angleMin = 104; int angleMax = 134; double angleBinWidth = 10; double exMin = 6; double exMax = 11; double exBinWidth = 0.05;
int angleBinNumb  = (angleMax-angleMin)/angleBinWidth; int exBinNumb = (exMax-exMin)/exBinWidth;
string drawstring =  "Ex:ThetaLab>>h(" + to_string(angleBinNumb) + "," 
                                       + to_string(angleMin)     + "," 
				       + to_string(angleMax)     + ","
				       + to_string(exBinNumb)    + ","
                                       + to_string(exMin)        + "," 
				       + to_string(exMax)        + ")";

vector<TGraphErrors*> parryPeakAoSA;  vector<TGraphErrors*> parryPeakdSdO;

TH2F* Parry_DrawPlots_ExpSubPSp(TChain* treeExp){
  LoadChain_PhaseSpace();
  TChain* treePSp = tree_PSp00;

  //Prepare
  gStyle->SetOptStat(0);
  TCanvas* cExp = new TCanvas("cExp","cExp",500,500);

  //GOOD EXP
  treeExp->Draw(drawstring.c_str(),gateG.c_str(),"");
  TH2F* hG = (TH2F*) gDirectory->Get("h");  hG->SetTitle("hG");  hG->SetName("hG");

  //BAD EXP
  treeExp->Draw(drawstring.c_str(),gateB.c_str(),"");
  TH2F* hB = (TH2F*) gDirectory->Get("h");  hB->SetTitle("hB");  hB->SetName("hB");

  //CLEAN EXP
  TH2F* hC = (TH2F*) hG->Clone();           hC->SetTitle("hC");  hC->SetName("hC");
  hC->Add(hB,-1);
  cExp->cd();  hC->Draw("colz");

  //PHASE SPACE
  TCanvas* cPSp = new TCanvas("cPSp","cPSp",500,500);
  treePSp->Draw(drawstring.c_str(),gateBase.c_str(),"");
  TH2F* hP = (TH2F*) gDirectory->Get("h");  hP->SetTitle("hP");  hP->SetName("hP");
  cPSp->cd();  hP->Draw("colz");

  //SCALE PHASE SPACE
  double scale = 1.0;
//  //for(int x=0; x<hC->GetNbinsX(); x++){
//  for(int x=hP->GetXaxis()->FindBin(110); x<hP->GetXaxis()->FindBin(122); x++){ 
//    //for(int y=0; y<hC->GetNbinsY(); y++){
//    for(int y=hP->GetYaxis()->FindBin(7.6); y<hP->GetYaxis()->FindBin(9.7); y++){ 
//      if(hP->GetYaxis()->GetBinCenter(y) < (-0.08*hP->GetXaxis()->GetBinCenter(x))+18.75){
//cout << hP->GetXaxis()->GetBinCenter(x) << " " << hP->GetYaxis()->GetBinCenter(y) << endl;
//      //if(hP->GetBinContent(x,y) > 0.002*hP->Integral() && hC->GetBinContent(x,y) > 10){
//      //if(hP->GetBinContent(x,y) > 0.005*hP->Integral() && hC->GetBinContent(x,y) > 30){
//      //if(hP->GetBinContent(x,y) > 0.0010*hP->Integral() && hC->GetBinContent(x,y) > 4){
//      //if(hP->GetBinContent(x,y) > 0.0010*hP->Integral() && hC->GetBinContent(x,y) > 2){
//        while((hP->GetBinContent(x,y))*scale > hC->GetBinContent(x,y)){
//          scale *= 0.999;
////cout << "  scaling... " << endl;
//	}
//      }
//    }
//  }
//  cout << "SCALE = " << scale << " !!! SHOULD BE AROUND 0.14!!!!" << endl;
  scale = 0.134256;  cout << GREEN << " USING SCALING FROM DrawEx_SubPSp(tree_both), scale = " << scale << RESET << endl;
  
  //CHECK SCALE PHASE SPACE
  TCanvas* cCheck = new TCanvas("cCheck","cCheck",500,500);
  TH1F* projC = (TH1F*) hC->ProjectionY();  projC->SetLineColor(kBlue);  
  TH1F* projP = (TH1F*) hP->ProjectionY();  projC->SetLineColor(kRed );  projP->Scale(scale);
  projC->Draw(); projP->Draw("same");
 
  //SUBTRACT PHASE SPACE
  TCanvas* cSub = new TCanvas("cSub","cSub",500,500);
  TH2F* hS = (TH2F*) hC->Clone();           hS->SetTitle("hS");  hS->SetName("hS");
  hS->Add(hP,-scale);
  hS->Draw("colz");

  //RETURN
  return hS;
}

vector<TH2F*> Parry_DrawPlots_SimPeaks(vector<int> peaks){
  vector<TH2F*> hSims;

  for(int p=0; p<peaksToFit.size(); p++){ 
    string path = basePath + to_string(peaks.at(p)) + ".root";
    string name = "peak" + to_string(peaks.at(p));
    TCanvas* c = new TCanvas(name.c_str(),name.c_str(),500,500);

    TFile *f = TFile::Open(path.c_str());
    TTree* tPeak=(TTree*)f->Get("PhysicsTree");

    tPeak->Draw(drawstring.c_str(),gateBase.c_str(),"");
    TH2F* htemp = (TH2F*) gDirectory->Get("h");  
    htemp->SetTitle(name.c_str());  htemp->SetName(name.c_str());
   
    hSims.push_back(htemp);
    c->cd();
    htemp->Draw("colz");
  }

  return hSims; 
}

vector<pair<double,double>> Parry_FitSingleAngle(TH1F* exp, TObjArray* sim, int angle, TFile* f){

  //DEFINITIONS
  double frac[sim->GetEntries()]; double fracerr[sim->GetEntries()];
  TFractionFitter* fracfit = new TFractionFitter(exp, sim,"V");
  //fracfit->SetRangeX(exp->FindBin(7.4), exp->FindBin(10.5));
  fracfit->SetRangeX(exp->FindBin(7.0), exp->FindBin(10.5));
  //fracfit->SetRangeX(exp->FindBin(7.0), exp->FindBin(8.7));
  for(int i=0; i<sim->GetEntries(); i++){ fracfit->Constrain(i,0.0,0.4); }
  //fracfit->ErrorAnalysis(2.0);

////TESTING WAYS TO CHANGE FIT OPTIONS TO FIX FIT FAILURE
//ROOT::Fit::Fitter* fitoptions = (ROOT::Fit::Fitter*)fracfit->GetFitter();
//ROOT::Math::MinimizerOptions opt = fitoptions->Config().MinimizerOptions();
//opt.SetDefaultPrecision(1e-2);
//opt.SetDefaultTolerance(1e-2);
//fitoptions->EvalFCN();
//fitoptions->Config().SetMinimizerOptions(opt); 


//for(int b=exp->FindBin(7.9); b<exp->FindBin(8.2); b++){ fracfit->ExcludeBin(b); }

  //PERFORM FIT
  Int_t fitstatus = fracfit->Fit();

  //CHECK IF FIT COMPLETED CORRECTLY
  if(fitstatus!=0){ for(int n=0; n<10; n++){cout << RED << "  FAILED TO FIT!" << endl;} }
  else { cout << GREEN << "  FRACTION FITTER SUCCESSFUL" << endl; }

  //EXTRACT RESULTS 
  fracfit->ReleaseRangeX();
  TH1F* result = (TH1F*) fracfit->GetPlot();
  result->SetLineColor(kRed); result->SetLineWidth(2); result->SetLineStyle(1);
  for(int i = 0; i<sim->GetEntries(); i++){ fracfit->GetResult(i, frac[i], fracerr[i]); }
 
  //OUTPUT RESULTS TO SCREEN
  for(int i = 0; i<sim->GetEntries(); i++){ cout << frac[i] << "+-" << fracerr[i] << " || "; }
  cout << endl;
  cout << "Chi2 / NDF = " << fracfit->GetChisquare() << " / "
                          << fracfit->GetNDF() << " = "
                          << fracfit->GetChisquare() / fracfit->GetNDF()
                          << RESET << endl;
  
  cout << "FIT PROBABILITY =  " << fracfit->GetProb() << endl;

  ofstream chi2file;
  chi2file.open("ParryFit_Chi2NDF.txt",std::ios_base::app);
  time_t timestamp; time(&timestamp);
  chi2file << ctime(&timestamp) << endl;
  chi2file << "    Peaks = ";
    for(int i=0; i<peaksToFit.size(); i++){ chi2file << peaksToFit[i] << " ";}
  chi2file << endl;
  chi2file << "    Chi2 / NDF = " << fracfit->GetChisquare() << " / "
                                  << fracfit->GetNDF() << " = "
                                  << fracfit->GetChisquare() / fracfit->GetNDF()
                                  << endl;
  
  chi2file.close();


  //SEE OUTPUTS
  string canvname = "canv" + to_string(angle);
  TCanvas* output = new TCanvas(canvname.c_str(),canvname.c_str(),500,500);
  exp->Draw("EL");
  result->Draw("same hist");
  for(int i=0; i<sim->GetEntries(); i++){
    double scale = (double)(exp->Integral()/((TH1F*) sim->At(i))->Integral())*(double)frac[i];
    cout << BLUE << " SCALING PEAK " << i << " BY VALUE " << scale << RESET << endl;
    ((TH1F*) sim->At(i))->Scale(scale);
    sim->At(i)->Draw("same hist");
  }

  f->cd();
  output->Write();

  vector<pair<double,double>> AllPeaksOneAngle;

  for(int i=0; i<sim->GetEntries(); i++){
    double tmp = (double)(((double)exp->Integral())/(((TH1F*) sim->At(i))->Integral()*(double)frac[i]));
    pair<double,double> PointErr ( tmp, (fracerr[i]/frac[i])*tmp );
    cout << exp->Integral() << " " 
         << ((TH1F*)sim->At(i))->Integral() << " " 
	 << frac[i] << " "
	 << tmp << " | "
	 << ((TH1F*) sim->At(i))->Integral() << " "
	 << (double)frac[i] << " "
	 << exp->Integral() << " "
	 << endl;
    AllPeaksOneAngle.push_back(PointErr);
  } 

  return AllPeaksOneAngle;
}

void Parry_RunWholeRange(){
  //Need to automate filling of vector<int> peaksToFit
  cout << " Fitting peaks: ";
  for(int i=0; i<peaksToFit.size(); i++){ cout << peaksToFit[i] << " ";}
  cout << endl;

  //Draw EXPERIMENTAL plots
  TH2F* hExp2D = Parry_DrawPlots_ExpSubPSp(tree_both); 

  //Draw SIMULATED plots
  vector<TH2F*> hSim2D = Parry_DrawPlots_SimPeaks(peaksToFit); 

  //Output file
  TFile* f = new TFile("ParryFunctionOutputs.root","RECREATE");

  //Cycle through angles to fit each single angle with peaks, and fill peak DCS plots
  for(int a=0; a<angleBinNumb; a++){
    string n = "hAng" + to_string(a);
    TH1F* hExp1D = (TH1F*) hExp2D->ProjectionY(n.c_str(), a, a+1);

    //Flatten over-subtracted bins
    for(int bin=0; bin<hExp1D->GetNbinsX(); bin++){
      if(hExp1D->GetBinContent(bin)<0){
        hExp1D->SetBinContent(bin,0);
        cout << "flatten bin " << bin << endl;
      }
    }
    hExp1D->SetLineColor(kBlack);  hExp1D->SetLineWidth(2);  hExp1D->SetLineStyle(1);
    hExp1D->GetYaxis()->SetRangeUser(0,400);
    TObjArray *fitSim = new TObjArray(peaksToFit.size());
    for(int p=0; p<peaksToFit.size(); p++){
      string n2 = n + "_Peak" + to_string(p);
      TH1F* hSim1D = (TH1F*) hSim2D[p]->ProjectionY(n2.c_str(), a, a+1);
      hSim1D->SetLineColor(kBlue);  hSim1D->SetLineWidth(2);  hSim1D->SetLineStyle(7);
      fitSim->Add(hSim1D);

      string graphname = "grPeak" + to_string(p);
      auto gr = new TGraphErrors();  
      gr->SetTitle(graphname.c_str());  gr->SetName(graphname.c_str());
      parryPeakAoSA.push_back(gr);
    }
 
    //Fit all peaks to single angle
    vector<pair<double,double>> AllPeaksOneAngle = Parry_FitSingleAngle(hExp1D, fitSim, a, f);

    //Extract all angles for single peaks, fill area (later divide by SA)
    for(int p=0; p<peaksToFit.size(); p++){
      parryPeakAoSA[p]->SetPoint(a, angleMin+(a*angleBinWidth), AllPeaksOneAngle[p].first);
      parryPeakAoSA[p]->SetPointError(a, 0., AllPeaksOneAngle[p].second);
    }
  }

  //Divide DCS by SA[sr] to get dSdO
  string filepathSA = "./SolidAngleHistFiles/SAHF_Sim_19Odp_";
  for(int p=0; p<peaksToFit.size(); p++){
    string filenameSA = filepathSA + to_string(peaksToFit[p]) + ".root";
    TFile* fileSA = TFile::Open(filenameSA.c_str());
    cout << " Using solid angle file " << filenameSA << endl;
    TH1F* SolidAngle = (TH1F*) fileSA->FindObjectAny("SolidAngle_Lab_MG");
    
    for(int a=0; a<angleBinNumb; a++){
      int binmin = SolidAngle->FindBin(angleMin+(a*angleBinWidth)-(0.5*angleBinWidth));
      int binmax = SolidAngle->FindBin(angleMin+(a*angleBinWidth)+(0.5*angleBinWidth));

      double SAerr; //[sr]
      double SA = SolidAngle->IntegralAndError(binmin, binmax, SAerr); //[sr]

      double val = parryPeakAoSA[p]->GetPointY(a);
      double err = parryPeakAoSA[p]->GetErrorY(a);
      parryPeakAoSA[p]->SetPointY(a, val/SA);
      parryPeakAoSA[p]->SetPointError(a, 0., (val/SA) * sqrt( pow( err/val, 2) + pow( SAerr/SA, 2) ));
    }
  }

  //Plot AoSA for each peak
  for(int p=0; p<peaksToFit.size(); p++){
    string cAoSAn = "cAoSA" + to_string(p);
    TCanvas* cAoSA = new TCanvas(cAoSAn.c_str(),cAoSAn.c_str(),500,500); 
    cAoSA->SetLogy();
    parryPeakAoSA[p]->GetYaxis()->SetRangeUser(1e-0,1e7);
    parryPeakAoSA[p]->SetTitle(to_string(peaksToFit[p]).c_str());
    parryPeakAoSA[p]->Draw();
  }


  cout << "!!!!!!!!!!!! MADE IT OUT !!!!!!!!!!!!" << endl;
}










