void MoveDirectoryTo(string newDir){
  cout << "--------------------------------------------------------" << endl;
  cout << "Moving directory from:" << endl;
  system("pwd");
  cout << "to:" << endl;
  chdir(newDir.c_str());
  system("pwd");
  cout << "--------------------------------------------------------" << endl;


}

TGraph* TWOFNR(double Ex, double Jf, double particleN, double particleL, double particleJ, double Ji){
 
  /* This funciton moves between directories in order to execute TWOFNR */
  /* and as such CANNOT be run on another machine!                      */



  cout << "========================================================" << endl;
  cout << "           BEGINING TWOFNR AUTOMATED PROCESS           " << endl;
  cout << "========================================================" << endl;
  
  //double Ex = 0.0;
  //double Ji = 2.5;
  //double Jf = 0.0;
  double QValue = 5.383 - Ex; //QValue for 19O(d,p)
  double BeamEnergy = 8.0;
  int beamA = 19, beamZ = 8;
  int model_in_A = 6; //JTandy (for now...)
  int model_in_B = 1; //Reid soft core (for now...)
//int model_out_A = 1; //BechettiGreenlees 
//int model_out_A = 2; //ChapelHill 
//int model_out_A = 3; //Menet 
  int model_out_A = 4; //Perey 
//int model_out_A = 5; //JLM
//int model_out_A = 6; //KoningDelaroche 

  string njjj;

  string twofnrDir = "/home/paxman/Programs/twofnr";

  char origDirChar[200];
  getcwd(origDirChar,200);
  string origDir{origDirChar};

  // Moving to TWOFNR directory
  MoveDirectoryTo(twofnrDir);

  // Delete existing tran.jjj and 24.jjj files
  remove("tran.jjj");
  remove("24.jjj");

  // Fill in.front file
  ofstream frontinput("in.front");
  /* name */ 				frontinput << "jjj" << endl;
  /* label */				frontinput << "auto" << endl;
  /* reaction - here (d,p) */		frontinput << 2 << endl;
  /* calcualte entrance DW */		frontinput << 0 << endl;
  /* calcualte exit DW */		frontinput << 0 << endl;
  /* beam energy per nucleon */		frontinput << BeamEnergy << endl;
  /* beam A, Z */			frontinput << beamA << " " << beamZ << endl;
  /* default integration range */ 	frontinput << 1 << endl;
  /* default number of partial waves */	frontinput << 1 << endl;
  /* default c.o.m steps */		frontinput << "0 0 0" << endl;
  /* L and J of transfered nucleon */	frontinput << particleL << " " << particleJ << endl;
  /* nodes in function (0s,0p,1s...)*/	frontinput << particleN << endl;
  /* calc using reaction Q value */	frontinput << 2 << endl;
  /* input reaction Q value */		frontinput << QValue << endl;
  /* no nonlocality in incident */	frontinput << 1 << endl;
  /* spin, incident channel */		frontinput << Ji << endl;
  /* use built-in potentials */		frontinput << 1 << endl;
  /*** select deut potential ***/	frontinput << model_in_A << endl;
  if(model_in_A==6){
  /*** select deut potential ***/	frontinput << model_in_B << endl;
  }
  /* no nonlocality in outgoing */	frontinput << 1 << endl;
  /* spin, outgoing channel */		frontinput << Jf << endl;
  /* use built-in potentials */		frontinput << 1 << endl;
  /*** select prot protential ***/	frontinput << model_out_A << endl;
  /*** switch case is to keep second selection consistent with first ***/
  switch(model_out_A){
    case 1:
      frontinput << 1 << endl;
      break;
    case 2:
      frontinput << 2 << endl;
      break;
    case 3:
      frontinput << 2 << endl;
      break;
    case 4:
      frontinput << 2 << endl;
      break;
    case 5:
      frontinput << 3 << endl;
      break;
    case 6:
      frontinput << 4 << endl;
      break;
  }
  /* default <p|d> vertex value */	frontinput << 1 << endl;
  /* use that value */			frontinput << 1 << endl;
  /* use zero range <d|p> vertex */	frontinput << 1 << endl;
  /* default neutron binding potent. */	frontinput << "1.25 0.65" << endl;
  /* default spin-orbit strengh */	frontinput << 6.0 << endl;
  /* default bound st. non-locality */	frontinput << 0 << endl;
  /* default bound st. s-o radius */	frontinput << 0 << endl;

  // Close in.front file
  frontinput.close();

  // Execute front20
  string exec_front = "(exec ";
  exec_front.append(twofnrDir);
  exec_front.append("/front20 < in.front > /dev/null)");

  cout << "Executing: " << exec_front << endl;
  system(exec_front.c_str());

  ifstream checkfront("tran.jjj");
  if(!checkfront){
    cout << "!!! ERROR !!! -> front20 failed" << endl;
    return 0;
  } else {
    cout << "front20 execution complete" << endl;
    checkfront.close();
  }


  // Fill in.twofnr file
  ofstream twofnrinput("in.twofnr");
  twofnrinput << "tran.jjj" << endl;
  twofnrinput.close();

  // Execute twofnr20
  string exec_twofnr = "(exec ";
  exec_twofnr.append(twofnrDir);
  exec_twofnr.append("/twofnr20 < in.twofnr > /dev/null)");

  cout << "Executing: " << exec_twofnr << endl;
  system(exec_twofnr.c_str());

  ifstream checktwofnr("24.jjj");
  if(!checktwofnr){
    cout << "!!! ERROR !!! -> twofnr20 failed" << endl;
    return 0;
  } else {
    cout << "twofnr20 execution complete" << endl;
    checktwofnr.close();
  }

  TGraph* DCS_Lab = new TGraph("24.jjj");
  cout << "Loaded DCS (lab), in units of mb/sr!" << endl;

  // Moving back to working directory
  MoveDirectoryTo(origDir); 


  return DCS_Lab;

}

void TWOFNR_CompareShapes(double Ex){

  TCanvas* twofnr = new TCanvas("twofnr","twofnr",1000,1000);
  twofnr->cd();  twofnr->SetLogy();

  TGraph* s12 = TWOFNR(Ex, 2., 1., 0., 0.5, 2.5);
  TGraph* p12 = TWOFNR(Ex, 2., 0., 1., 0.5, 2.5);
  TGraph* d52 = TWOFNR(Ex, 0., 0., 2., 2.5, 2.5);
  TGraph* f72 = TWOFNR(Ex, 3., 0., 3., 3.5, 2.5);

  s12->SetLineColor(kRed);    s12->SetLineWidth(2); s12->SetLineStyle(1);
  p12->SetLineColor(kGreen);  p12->SetLineWidth(1); p12->SetLineStyle(7);
  d52->SetLineColor(kBlue);   d52->SetLineWidth(2); d52->SetLineStyle(1);
  f72->SetLineColor(kViolet); f72->SetLineWidth(1); f72->SetLineStyle(7);

  s12->Draw();
  p12->Draw("same");
  d52->Draw("same");
  f72->Draw("same");

  auto legend = new TLegend(0.6,0.1,0.9,0.9);
  legend->AddEntry(s12,"s1/2","L");
  legend->AddEntry(p12,"p1/2","L");
  legend->AddEntry(d52,"d5/2","L");
  legend->AddEntry(f72,"f7/2","L");
  legend->Draw();

}
