#!/bin/bash

rm RunToTreat_AutoGenerated.txt
rm ./Reaction/Auto.reaction
rm ./Reaction/AutoPhaseSpace.reaction

XYZTdate="18Oct22"
sp=" "

rfile_phspc='Reaction/AutoPhaseSpace.reaction'
rfile_npana='Reaction/Auto.reaction'
dfile="./Detector/mugast_"$XYZTdate".detector"

E=$(echo "scale=3; $2/1000" | bc -l)

#==============================================================================================
#Boilerplate
echo -e "%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%" 		  >> ./Reaction/Auto.reaction
echo -e "Beam" 						  >> ./Reaction/Auto.reaction
echo -e "$sp""Particle=""$sp""47K" 			  >> ./Reaction/Auto.reaction
echo -e "$sp""ExcitationEnergy=""$sp""0""$sp""MeV" 	  >> ./Reaction/Auto.reaction
echo -e "$sp""Energy=""$sp""354.75""$sp""MeV" 		  >> ./Reaction/Auto.reaction
echo -e "$sp""SigmaEnergy=""$sp""0.""$sp"" MeV" 	  >> ./Reaction/Auto.reaction
echo -e "$sp""SigmaThetaX=""$sp""0.0""$sp""deg" 	  >> ./Reaction/Auto.reaction
echo -e "$sp""SigmaPhiY=""$sp""0.0""$sp""deg"	 	  >> ./Reaction/Auto.reaction
echo -e "$sp""SigmaX=""$sp""2.0""$sp""millimeter" 	  >> ./Reaction/Auto.reaction
echo -e "$sp""SigmaY=""$sp""2.0""$sp""millimeter"	  >> ./Reaction/Auto.reaction
echo -e "$sp""MeanThetaX=""$sp""0""$sp""deg"	  	  >> ./Reaction/Auto.reaction
echo -e "$sp""MeanPhiY=""$sp""0""$sp""deg" 		  >> ./Reaction/Auto.reaction
echo -e "$sp""MeanX=""$sp""-4.1561""$sp""millimeter" 	  >> ./Reaction/Auto.reaction
echo -e "$sp""MeanY=""$sp""+0.4701""$sp""millimeter" 	  >> ./Reaction/Auto.reaction
echo -e "%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%" 		  >> ./Reaction/Auto.reaction
echo -e "TwoBodyReaction" 				  >> ./Reaction/Auto.reaction
echo -e "$sp""Beam=""$sp""47K" 				  >> ./Reaction/Auto.reaction
echo -e "$sp""Target=""$sp""2H" 			  >> ./Reaction/Auto.reaction
echo -e "$sp""Light=""$sp""1H" 			  	  >> ./Reaction/Auto.reaction
echo -e "$sp""Heavy=""$sp""48K" 			  >> ./Reaction/Auto.reaction
echo -e "$sp""ExcitationEnergyLight=""$sp""0.0""$sp""MeV" >> ./Reaction/Auto.reaction
echo -e "$sp""ExcitationEnergyHeavy=""$sp""$E""$sp""MeV"  >> ./Reaction/Auto.reaction
echo -e "$sp""CrossSectionPath=""$sp""flat.txt""$sp""CSR" >> ./Reaction/Auto.reaction
echo -e "$sp""ShootLight=""$sp""1" 			  >> ./Reaction/Auto.reaction
echo -e "$sp""ShootHeavy=""$sp""0" 			  >> ./Reaction/Auto.reaction

#==============================================================================================

echo -e "%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%" 		                    >> ./Reaction/AutoPhaseSpace.reaction
echo -e "Beam" 						                    >> ./Reaction/AutoPhaseSpace.reaction
echo -e "$sp""Particle=""$sp""47K" 			                    >> ./Reaction/AutoPhaseSpace.reaction
echo -e "$sp""ExcitationEnergy=""$sp""0""$sp""MeV" 	                    >> ./Reaction/AutoPhaseSpace.reaction
echo -e "$sp""Energy=""$sp""354.75""$sp""MeV" 		                    >> ./Reaction/AutoPhaseSpace.reaction
echo -e "$sp""SigmaEnergy=""$sp""0.""$sp"" MeV" 	                    >> ./Reaction/AutoPhaseSpace.reaction
echo -e "$sp""SigmaThetaX=""$sp""0.0""$sp""deg" 	                    >> ./Reaction/AutoPhaseSpace.reaction
echo -e "$sp""SigmaPhiY=""$sp""0.0""$sp""deg"	 	                    >> ./Reaction/AutoPhaseSpace.reaction
echo -e "$sp""SigmaX=""$sp""2.0""$sp""millimeter" 	                    >> ./Reaction/AutoPhaseSpace.reaction
echo -e "$sp""SigmaY=""$sp""2.0""$sp""millimeter"	                    >> ./Reaction/AutoPhaseSpace.reaction
echo -e "$sp""MeanThetaX=""$sp""0""$sp""deg"	  	                    >> ./Reaction/AutoPhaseSpace.reaction
echo -e "$sp""MeanPhiY=""$sp""0""$sp""deg" 		                    >> ./Reaction/AutoPhaseSpace.reaction
echo -e "$sp""MeanX=""$sp""-4.1561""$sp""millimeter" 	                    >> ./Reaction/AutoPhaseSpace.reaction
echo -e "$sp""MeanY=""$sp""+0.4701""$sp""millimeter" 	                    >> ./Reaction/AutoPhaseSpace.reaction
echo -e "%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%" 		                    >> ./Reaction/AutoPhaseSpace.reaction
echo -e "PhaseSpace"     				                    >> ./Reaction/AutoPhaseSpace.reaction
echo -e "$sp""Beam=""$sp""47K" 				                    >> ./Reaction/AutoPhaseSpace.reaction
echo -e "$sp""Target=""$sp""2H" 			                    >> ./Reaction/AutoPhaseSpace.reaction
echo -e "$sp""Daughters=""$sp""1H""$sp""47K""$sp""n"                        >> ./Reaction/AutoPhaseSpace.reaction
echo -e "$sp""ExcitationEnergies=""$sp""0.0""$sp""$E""$sp""0.0""$sp""MeV"   >> ./Reaction/AutoPhaseSpace.reaction
echo -e "$sp""Fermi=""$sp""1"    			                    >> ./Reaction/AutoPhaseSpace.reaction

cd ~/Programs/nptool/Projects/e793s;
cmake ./;
make -j6;

directory=' /home/charlottepaxman/Programs/nptool/Outputs/Simulation/'
dotroot='.root'

nameconstruct=$XYZTdate"_"$1"_01Dec23"
echo "Name: $nameconstruct"
echo "Reaction file: $rfile_phspc"
echo "Detector file: $dfile"

mvnamesim_part="/media/charlottepaxman/Elements1/ActiveWork_47K/Simulation/""$nameconstruct"
sp=" "

echo "TTreeName" > RunToTreat_AutoGenerated.txt
echo " SimulatedTree" >> RunToTreat_AutoGenerated.txt
echo "RootFileName" >> RunToTreat_AutoGenerated.txt

for x in {1..64} 
do
        outname=$nameconstruct"-"$x
	npsimulation -D $dfile -E $rfile_phspc -B ./runsimulation.mac --random-seed $RANDOM -O $outname;
        mv "../../Outputs/Simulation/""$outname"".root" "$mvnamesim_part""-""$x"".root" 
	echo "$sp""$mvnamesim_part""-""$x"".root" >> RunToTreat_AutoGenerated.txt
done

outfile="Sim_"$nameconstruct

npanalysis --definition PhS -R RunToTreat_AutoGenerated.txt -E $rfile_npana -D $dfile -O $outfile;
