TGraphErrors* GetYield(string);

void Draw(int A, string isotope, TGraphErrors* ge, int, int, double);


vector<int> vZ;
vector<int> vA;
vector<int> vN;
vector<string> visoname;
vector<string> yield_file;

int NumberOfZ=0;
int NumberOfN=0;

////////////////////////////////////////////
void MapAll()
{
  gROOT->SetStyle("pierre_style");

  string filename = "list1.dat";
  ifstream ifile;
  ifile.open(filename.c_str());

  int Z=0;
  int Zprev=0;
  int A;
  NPL::Particle* iso;
  while(ifile>>Z>>A){
    //ifile >> Z >> A;
    iso = new NPL::Particle(Z,A);
    string isoname = iso->GetName();
    isoname.resize(5);
    string yield_filename = "dat/yield_" + isoname + ".dat";
    yield_file.push_back(yield_filename);
    cout << yield_filename << endl;
    if(Z!=Zprev){
      Zprev = Z;
      NumberOfZ++;
    }
    vZ.push_back(Z);
    vA.push_back(A);
    vN.push_back(A-Z);
    visoname.push_back(isoname);
  }
  NumberOfN = vN[vN.size()-1] - vN[0] + 1;
  cout << "***** " << NumberOfZ << " different element to be plotted !" << endl; 
  cout << "***** " << NumberOfN << " number of neutrons" << endl; 
  cout << "size " << vZ.size() << " " << NumberOfZ*NumberOfN << endl;

  TCanvas* c1 = new TCanvas("Map1","Map1",2400,1500);
    
  //c1->Divide(NumberOfN,NumberOfZ,0,0);
  c1->Divide(9,7,0,0);
  c1->Modified();

  int Nmin = vN[0];
  int Zmin = vZ[0];
  int Zmax = vZ[vZ.size()-1];
  int Nmax = vN[vN.size()-1];
  int DeltaZ = 0;
  int DeltaN = 0;
  int indice = 0;
  int j = 0;
  for(int i=0; i<vZ.size(); i++){
    DeltaN = vN[i] - Nmin;
    if(DeltaZ != abs(vZ[i] - Zmax)){
      DeltaZ = abs(vZ[i] - Zmax);
      j= 0;
    }
    indice = j + 9*DeltaZ;
    j++;
    cout << vZ[i] << " " << vN[i] << " " << indice << endl;
    c1->cd(indice+1);
    double scale=1;
    if(indice<54) scale = 1.17;

    string isoname = visoname[i].substr(3);
    Draw(vA[i],isoname,GetYield(yield_file[i]),26,55, scale);
  }
  ifile.close();

  vZ.clear();
  vA.clear();
  vN.clear();
  visoname.clear();
  yield_file.clear();
  NumberOfN=0;
  NumberOfZ=0;

  filename = "list2.dat";
  ifile.open(filename.c_str());

  Z=0;
  Zprev=0;
  A=0;
  while(ifile>>Z>>A){
    //ifile >> Z >> A;
    iso = new NPL::Particle(Z,A);
    string isoname = iso->GetName();
    isoname.resize(5);
    string yield_filename = "dat/yield_" + isoname + ".dat";
    yield_file.push_back(yield_filename);
    cout << yield_filename << endl;
    if(Z!=Zprev){
      Zprev = Z;
      NumberOfZ++;
    }
    vZ.push_back(Z);
    vA.push_back(A);
    vN.push_back(A-Z);
    visoname.push_back(isoname);
  }
  NumberOfN = vN[vN.size()-1] - vN[0] + 1;
  cout << "***** " << NumberOfZ << " different element to be plotted !" << endl; 
  cout << "***** " << NumberOfN << " number of neutrons" << endl; 
  cout << "size " << vZ.size() << " " << NumberOfZ*NumberOfN << endl;

  TCanvas* c2 = new TCanvas("Map2","Map2",2400,1500);
    
  c2->Divide(10,7,0,0);
  c2->Modified();

  Nmin = vN[0];
  Zmin = vZ[0];
  Zmax = vZ[vZ.size()-1];
  Nmax = vN[vN.size()-1];
  DeltaZ = 0;
  j=0;
  for(int i=0; i<vZ.size(); i++){
    DeltaN = vN[i] - Nmin;
    if(DeltaZ != abs(vZ[i] - Zmax)){
      DeltaZ = abs(vZ[i] - Zmax);
      j= 0;
    }
    indice = j + 10*DeltaZ;
    j++;
    cout << vZ[i] << " " << vN[i] << " " << indice << endl;
    c2->cd(indice+1);
    double scale = 1;
    if(indice<60) scale = 1.17;
    
    string isoname = visoname[i].substr(3);
    Draw(vA[i],isoname,GetYield(yield_file[i]),29,57,scale);
  }
  ifile.close();


}

////////////////////////////////////////////
void Draw(int A, string isoname, TGraphErrors* ge, int Zmin, int Zmax,double scale){
  string isotope = "^{" + to_string(A) + "}" + isoname;
  TLatex* iso = new TLatex(46,23,isotope.c_str());
  iso->SetTextFont(42);
  iso->SetTextSize(0.15*scale);

  TH2F* h2 = new TH2F("h2","h2",500,20,60,500,0,30);
  h2->GetXaxis()->SetTitle("Z");
  h2->GetYaxis()->SetTitle("Y(Z) (%)");
  h2->GetXaxis()->CenterTitle();
  h2->GetYaxis()->CenterTitle();
  h2->GetXaxis()->SetRangeUser(Zmin,Zmax);
  h2->GetYaxis()->SetRangeUser(0.1,29);

  h2->GetXaxis()->SetLabelSize(0.1*scale);
  h2->GetXaxis()->SetTitleSize(0.11*scale);
  h2->GetXaxis()->SetTitleOffset(0.75);
  h2->GetYaxis()->SetLabelSize(0.1*scale);
  h2->GetYaxis()->SetTitleSize(0.11*scale);
  h2->GetYaxis()->SetTitleOffset(0.65*1./scale);


  h2->Draw();
  iso->Draw();
  ge->SetFillColor(kAzure-6);
  ge->Draw("plfsame");
  ge->Draw("psame");
}

////////////////////////////////////////////
TGraphErrors* GetYield(string filename)
{
  ifstream ifile;

  ifile.open(filename.c_str());

  int Z;
  double yield;
  double yield_err;
  TGraphErrors* g = new TGraphErrors();
  int i=0;
  while(!ifile.eof()){
    ifile >> Z >> yield >> yield_err;
    //cout << Z << " " << yield << " " << yield_err << endl;
    if(yield>0 && yield_err>0){
      g->SetPoint(i,Z,yield);
      g->SetPointError(i,0,yield_err);
      i++;
    }
  }

  g->SetMarkerStyle(8);

  ifile.close();
  return g;
}


